<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
</head>

<body>
    <script>
        const articles = [
            { id: 1, titre: "article 1", like: 10, id_auteur: 1 },
            { id: 2, titre: "article 2", like: 0, id_auteur: 3 },
            { id: 3, titre: "article 3", like: 15, id_auteur: 1 },
            { id: 4, titre: "article 4", like: 1, id_auteur: 2 },
        ]
        const auteurs = [
            { id: 1, nom: "Alain", isActif: true },
            { id: 2, nom: "Béatrice", isActif: false },
            { id: 3, nom: "Charles", isActif: true }
        ]
        const commentaires = [
            { id: 1, contenu: "lorem 1", id_article: 4 },
            { id: 2, contenu: "lorem 2", id_article: 1 },
            { id: 3, contenu: "lorem 3", id_article: 2 },
            { id: 4, contenu: "lorem 4", id_article: 2 },
            { id: 5, contenu: "lorem 5", id_article: 1 },
        ]
        const data = articles.map(article => {
            let auteur = auteurs.find(auteur => {
                return article.id_auteur == auteur.id
            });
            return {
                id: article.id,
                titre: article.titre,
                like: article.like,
                auteur: auteur,
                commentaires: commentaires.filter(commentaire => {
                    if (commentaire.id_article === article.id) {
                        if (auteur.isActif === true) {
                            delete commentaire.id_article;
                        }
                        return commentaire;
                    }
                }
                )

            }

        })


        console.log(data);
    </script>
</body>

</html>